// DemoC021n1_proto.h
// 
// prototypes
///////////////////////////////////////////////////////////////////////////////


/*-------------------------------------------------------------------------
   Written by: 
   Peter Seng (2005)
   
   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   In other words, you are welcome to use, share and improve this program.
   You are forbidden to forbid anyone else to use, share and improve
   what you give them.   Help stamp out software-hoarding!
-------------------------------------------------------------------------*/


#ifndef PROTOTYPES_H
#define PROTOTYPES_H

// ISR-Prototypes
void External0_ISR(void) interrupt 0; // ISR for the external input INT0
void Timer0_ISR(void)    interrupt 1; // ISR for Timer0 overflow
void External1_ISR(void) interrupt 2; // ISR for the external input INT1
void Timer1_ISR(void)    interrupt 3; // ISR for Timer1 overflow
void Serial_ISR(void)    interrupt 4; // ISR for serial reception
void Timer2_ISR(void)    interrupt 5; // ISR for Timer2 overflow
void delay(unsigned int time_100us); // Routine waits (dependening on Timer 1) for about delaytime * 100s

// UART
void errormsg(unsigned char ascii); // Generates a error message via UART
void putchar(unsigned char value); // Sends a character via UART
void UART_puts(unsigned char *text); // Sends a string to the UART
void UART_putsCrLf(unsigned char *text, unsigned char ucCrLf); // Sends a string to the UART, optionally add CR and LF
void UART_putsFiltered(unsigned char *text, unsigned char ucFilter); // Sends a filtered string to the UART
unsigned int RXChar(void); // Reads a character out of the RX buffer
void UART_printIntDot(unsigned char ucDigits, char ucShowLz, char cDec, int iA); // print int value to UART as (1-5 digit + sign + dot) = 3-7 digit decimal value

// diverse
void init_MCU(void); // Initialize the MCU
void MsDelay(unsigned int iMsDelay); // stop programm execution for iMsDelay * ms
void setTimeOut(unsigned long ul100us); // set timeout timer
unsigned char checkTimeOut(void); // check timeout timer
void LedOn(unsigned char ucState); // switch Led connected to port of CPU on/off
void MsgLed(unsigned char ucMsgNr, unsigned char ucLoop); // show message via flashing LED, amount of flashes identifies message

#endif
